//Tetris Forever V1.4 14.03.2005
//Copyright (C) 2005 Arian Perek 
//adrianperek@o2.pl, kalkulatoryti.fm.interia.pl
  
#define USE_TI89              
#define USE_TI92PLUS          
#define USE_V200              
#define OPTIMIZE_ROM_CALLS    
#define MIN_AMS 100                    
#include <tigcclib.h>         
LCD_BUFFER buffer;

int k1_[32]={6,2,7,2,8,2,8,3,	 7,1,7,2,7,3,6,3,	 6,1,6,2,7,2,8,2,	 7,1,8,1,7,2,7,3};
int k2_[32]={6,3,7,3,8,3,9,3,	 7,1,7,2,7,3,7,4,	 6,3,7,3,8,3,9,3,	 7,1,7,2,7,3,7,4};
int k3_[32]={6,1,7,1,6,2,7,2,	 6,1,7,1,6,2,7,2,	 6,1,7,1,6,2,7,2,	 6,1,7,1,6,2,7,2};
int k4_[32]={6,1,7,1,8,1,7,2,	 7,1,7,2,7,3,6,2,	 6,2,7,2,8,2,7,1,	 7,1,7,2,7,3,8,2};
int k5_[32]={6,1,7,1,7,2,8,2,	 8,1,7,2,7,3,8,2,	 6,2,7,2,7,3,8,3,	 7,1,7,2,6,2,6,3};
int k6_[32]={6,2,7,2,8,2,8,1,	 7,1,7,2,7,3,8,3,	 6,3,6,2,7,2,8,2,	 7,1,6,1,7,2,7,3};
int k7_[32]={8,1,9,1,7,2,8,2,	 8,1,8,2,9,2,9,3,	 7,3,8,2,8,3,9,2,	 7,1,7,2,8,2,8,3};

struct block;
int _check(struct block *,int,int,int);
int f=1;
int LV=0;

struct stat{
int points,line, best;
}game;

struct point {
		int x,y,s;
}matrix[20][14], buf[4];

struct block{
	  struct point kl[16];
	  int *wsp;
}wsk[7];

void _shape(struct block *this, int *t)
{
	int i;
	for (i=15; i>-1; i--)
	{	if (t[2*i])
  	{	
  		this->kl[i].x=t[2*i];
			this->kl[i].y=t[2*i+1];
			this->kl[i].s=1;	
		}
  	this->wsp=t;
	}
}

int _move(struct block *this, int x,int y,int od)
{ 
	int check=0; 
	int i;
	check=_check(this, x,y,od);
	if (!check)
	for (i=15;i>-1;i--)
	{	
		this->kl[i].x+=x;
		this->kl[i].y+=y;	
	}
	else
		if (y==1)
	 	{		for (i=od; i<(od+4); i++)
		  	{	///////////////x
		  		matrix[this->kl[i].y-1][this->kl[i].x-1].s=this->kl[i].s;
			  }
	 		_shape(this,this->wsp);
	 		return check;
	 	}
	return 0;
};

void	_draw(struct block *this,int od)
{
	int i;	
	if (!f)  //usuniecie poprzedniego polozenia klocka
			for ( i=3; i>-1; i--)
		    DrawChar(5*buf[i].x, 5*(buf[i].y-1), 0x10, A_XOR);
	 f=0;	
	 for (i=3;i>-1;i--)  buf[i]=this->kl[i+od];
	
	 for (i=od;i<(od+4);i++)
    	DrawChar(5*this->kl[i].x, 5*(this->kl[i].y-1), 0x10, A_NORMAL);
}

int _check(struct block *this,int x, int y,int od)
{		int i;
		for (i=od;i<(od+4);i++)
			if ((matrix[this->kl[i].y-1+y][this->kl[i].x-1+x].s+this->kl[i].s)>1)
				return this->kl[i].y;	
return 0;
}

void _refresh(void)
{	int ww; 
	int ko;
	for (ww=19; ww>-1; ww--)
	for (ko=13; ko>-1; ko--)
			if (matrix[ww][ko].s==1)
       	DrawChar(5*(ko+1), 5*(ww), 0x10, A_NORMAL);
    		    		
  printf_xy (80, 5, "Next");
  printf_xy (80, 50, "Score:%d", game.points);
  printf_xy (80, 65, "Lines:%d", game.line);
  printf_xy (80, 80, "Best:%d", game.best);
  FontSetSys (F_4x6);
  printf_xy (82, 94, "TETRIS_F v1.4"); 
  FontSetSys (F_6x8);
  	static WIN_RECT rect = {78, 2, 135, 92};
   DrawClipRect (&rect, ScrRect, A_NORMAL);   
}

void delayt(int t)
{ OSFreeTimer (USER_TIMER);
	OSRegisterTimer (USER_TIMER, t);
	while (!OSTimerExpired (USER_TIMER));
}

void _next(int which, int next)
{ int i;
	for (i=0;i<4;i++)
    	DrawChar(70+5*wsk[which].kl[i].x, 15+5*wsk[which].kl[i].y, 0x10, A_XOR);
 	for (i=0;i<4;i++)
    	DrawChar(70+5*wsk[next].kl[i].x, 15+5*wsk[next].kl[i].y, 0x10, A_NORMAL);
}

void _start_game(void)
{	clrscr();
	FontSetSys (F_6x8);
  int w, ww, ko, next=random(7);
	 int i,s, where;
	 int ile=0;
 	int z=1;
 	int t[4]={0,4,8,12};
 	int which=random(7);
	static WIN_RECT rect = {29, 38, 120, 50};

	for (ww=0; ww<20; ww++)
	{	matrix[ww][0].s=1;
 		matrix[ww][13].s=1; }

	for (ko=0; ko<14; ko++) matrix[19][ko].s=1;

 	randomize();
 	_refresh();

	for (i=0;i<4;i++)
    	DrawChar(70+5*wsk[next].kl[i].x, 15+5*wsk[next].kl[i].y, 0x10, A_NORMAL);

OSInitKeyInitDelay (50); 
while(1)
 {
	for (i=0; i<22-LV; i++)
		{ 
			if (kbhit())
			{ 
	 			if (_keytest (RR_DOWN)) break; 
	 			if (_keytest (RR_RIGHT)) {_move(&wsk[which],1,0,t[z-1]); 
	 			GKeyFlush(); 
	 			}
	 			if (_keytest (RR_LEFT)) {_move(&wsk[which],-1,0,t[z-1]); 
	 			GKeyFlush(); 
	 			}
	 			if (_keytest (RR_UP)) 
	 			 {  
	      s=z;
	 					s>3 ? s=1 : s++;
	 					if (!_check(&wsk[which], 0,0,t[s-1]))
							z=s;	
							GKeyFlush ();
						}
	 			if (_keytest (RR_APPS)) {GKeyFlush (); ngetchx();}
	 			if (_keytest (RR_ESC)) break; 
	 			 	
				_draw(&wsk[which], t[z-1]);
			} 
			delayt(1);
			
		}		delayt(1);
		if (_keytest (RR_ESC)) break;
	 	
	 	_draw(&wsk[which], t[z-1]);
	 	where=_move(&wsk[which], 0,1,t[z-1]);
	 	i=0;
	 	
	 	if (where>3)
		{
			 f=1;
			 which=next;
			 next=random(7);			 				
 			 _next(which, next);
 			 
			for (w=0;w<19;w++)
			{     ile=0;
						for (ko=1;ko<13;ko++)
							ile+=matrix[w][ko].s;
							
						if (ile>11)
		  			{ i++;
		  				for (ww=w;ww>0;ww--)
			  			for (ko=0;ko<14;ko++)
				 				matrix[ww][ko]=matrix[ww-1][ko];
				 				clrscr();
				 				_refresh();
				 				_next(next, next);
		  			}
			}
			game.line+=i;
			i*=i;
			game.points+=i;
			_refresh();
		} //end if (move)
		else
			if ((where<=3) && (where>0))
			{ while(kbhit()) ngetchx();
				FontSetSys (F_8x10);
				printf_xy(30,40, " GAME OVER ");
				DrawClipRect (&rect, ScrRect, A_NORMAL); 
				
					delayt(25);			
				ngetchx();
				break;
			}
  }//end while(1)	
}

void _main(void)
{
 LCD_save (buffer);
 	clrscr(); 
 int *p=&game.best;
 FILE *ff = fopen ("t_score", "rb");
 if (ff) fread(p,2,1,ff);
 fclose (ff);
 game.best=*p;
 
 _shape(&wsk[0],k1_);
	_shape(&wsk[1],k2_);
	_shape(&wsk[2],k3_);
	_shape(&wsk[3],k4_);
	_shape(&wsk[4],k5_);
	_shape(&wsk[5],k6_);
	_shape(&wsk[6],k7_);


int ws=0; int key,i;

static WIN_RECT rect = {45, 23, 113, 75};
static WIN_RECT rect1 = {1, 1, 159, 90};
DrawClipRect (&rect, ScrRect, A_NORMAL);
DrawClipRect (&rect1, ScrRect, A_NORMAL);
FontSetSys (F_8x10);
DrawChar(50, 30, 0x12, A_NORMAL);
DrawStr(3, 5, "Tetris Forever V1.4", A_NORMAL);
DrawStr(60, 30, "Start", A_NORMAL);
DrawStr(60, 45, "Level", A_NORMAL);
DrawStr(60, 60, "Exit", A_NORMAL);
FontSetSys (F_6x8);
DrawStr(5, 80, "by Adrian Perek (c) 2005", A_NORMAL);
for (i=0;i<4;i++)
    	{
    		 DrawChar(5*wsk[4].kl[i].x-19, 37+5*wsk[4].kl[i].y, 0x10, A_NORMAL);
    			DrawChar(5*wsk[4].kl[i].x+102, 37+5*wsk[4].kl[i].y, 0x10, A_NORMAL);
    			DrawChar(5*wsk[1].kl[i].x-28, 6+5*wsk[1].kl[i].y, 0x10, A_NORMAL);
    			DrawChar(5*wsk[1].kl[i].x-8, 6+5*wsk[1].kl[i].y, 0x10, A_NORMAL);
    			DrawChar(5*wsk[1].kl[i].x+86, 6+5*wsk[1].kl[i].y, 0x10, A_NORMAL);
    			DrawChar(5*wsk[1].kl[i].x+106, 6+5*wsk[1].kl[i].y, 0x10, A_NORMAL);
    			DrawChar(5*wsk[1].kl[i].x-28, 53+5*wsk[1].kl[i].y, 0x10, A_NORMAL);
    			DrawChar(5*wsk[1].kl[i].x-8, 53+5*wsk[1].kl[i].y, 0x10, A_NORMAL);
    			DrawChar(5*wsk[1].kl[i].x+86, 53+5*wsk[1].kl[i].y, 0x10, A_NORMAL);
    			DrawChar(5*wsk[1].kl[i].x+106, 53+5*wsk[1].kl[i].y, 0x10, A_NORMAL);
    	}

while(1){
	if (kbhit())
			{ 
			key=ngetchx();
			FontSetSys (F_8x10);
	 			if (key==KEY_DOWN) {	if (ws<2) {ws++;
					DrawChar(50, 30+15*ws, 0x12, A_NORMAL);
					DrawChar(50, 30+15*ws-15, 0x12, A_XOR);}
					}
				if (key==KEY_UP) {	if (ws>0) {ws--;
					DrawChar(50, 30+15*ws, 0x12, A_NORMAL);
					DrawChar(50, 30+15*ws+15, 0x12, A_XOR);}
					}
				if (ws==1){
				if (key==KEY_RIGHT) {if (LV<18) LV+=3; printf_xy(101,45,"%d",LV/3); }
				if (key==KEY_LEFT)  {if (LV>0) LV-=3; printf_xy(101,45,"%d",LV/3); }
			  }
			  if (key==13) 
				{
					if (ws==0) {_start_game(); break;}
					if (ws==2) break;
				}
 		}
}
			
if (game.points>game.best) 
{
	clrscr();
	FontSetSys (F_8x10);
	GKeyFlush ();
	game.best=game.points;
	printf_xy(5,40,"New high score: %d", game.best);	
	ngetchx();	
}
			
int *p2=&game.best;
FILE *f = fopen ("t_score", "wb");
if (f) fwrite(p2, 2,1, f) ;
fclose (f);
	
LCD_restore (buffer);
}